<?php
/*
Plugin Name: Twitter Hashtag-based Conversation
Plugin URI: http://pixeline.be
Description: Displays the most recent twitter status updates for a particular hash tag in your posts/pages using shortcode: [twitter_hashtag hash="YOUR_TAG" number="NUMBER_OF_TWEETS_TO_GET" ].
Version: 1
Author: pixeline
Author URI: http://www.pixeline.be
*/
/*  Copyright 2012  pixeline  (email : alexandre@pixeline.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

add_action('wp_print_scripts', 'pth_add_javascript');

function pth_add_javascript(){
if(!is_admin()){
 $pth_plugin_url = plugin_dir_url(__FILE__);
 wp_enqueue_script('jquery');
 wp_enqueue_script('pixeline_hashtag_conversation_js', $pth_plugin_url.'/twitter-hashtag-conversation.js', array('jquery'));

}
}

function pixeline_twitter_hashtag($atts, $content = null){
		$opt_name = array('default_tag' =>'pxlntwttrhshtg_default_tag', 
		'default_number'=>'pxlntwttrhshtg_default_number', 
		'loading_str'=>'pxlntwttrhshtg_loading_str',
		'update_str'=>'pxlntwttrhshtg_update_str',
		'refresh_rate'=>'pxlntwttrhshtg_refresh_rate',
		'title'=>'pxlntwttrhshtg_title'
		);
		$default_hashtag = get_option($opt_name['default_tag']);
		$default_number = get_option($opt_name['default_number']);
		$loading_str = get_option($opt_name['loading_str']);
		$update_str =  get_option($opt_name['update_str']);
		$refresh_rate =  get_option($opt_name['refresh_rate']);
		$refresh_rate = $refresh_rate*1000;
		
		$default_title =  get_option($opt_name['title']);
	
			
        extract(shortcode_atts(array(
                "hash" => $default_hashtag,
                "number" => $default_number,
                "title" => $default_title,
                ), $atts));

		$search  = array('{HASH}', '{NUMBER}','{HASH_LINK}');
		$replace = array($hash, $number,'<a href="http://search.twitter.com/search?q=%23'.$hash.'" target="_blank" class="pth_hash_link">'.$hash.'</a>');
		$default_title = str_ireplace($search, $replace, $default_title);
		
		
        $query_url = "http://search.twitter.com/search.json?q=%23$hash&rpp=$number&callback=?";
        
        $output = '<h2>'.$default_title.'</h2>';
        $output .= '<div id="tht_tweet_container" class="twitter-hash-tag">'.$loading_str.'</div>';

		$output .='<script type="text/javascript">
		var pixeline_twitter_hashtag={url:"'.$query_url.'",update_str:"'.$update_str.'", refresh_rate:"'.$refresh_rate.'", tag:"'.$hash.'"};
		</script>';
        return $output;
}

add_shortcode("twitter_hashtag", "pixeline_twitter_hashtag");


//* --- !ADMIN OPTIONS --- */

// create custom plugin settings menu

add_action('admin_menu', 'pth_create_menu');

function pth_create_menu() {

	//create new top-level menu
	add_options_page('Pixeline Twitter Hashtag Settings', 'Twitter Hashtag Conversation', 'manage_options', __FILE__, 'pth_settings_page');

}


//!Settings page

function pth_settings_page(){
		$opt_name = array('default_tag' =>'pxlntwttrhshtg_default_tag', 
		'default_number'=>'pxlntwttrhshtg_default_number', 
		'loading_str'=>'pxlntwttrhshtg_loading_str',
		'update_str'=>'pxlntwttrhshtg_update_str',
		'refresh_rate'=>'pxlntwttrhshtg_refresh_rate',
		'title'=>'pxlntwttrhshtg_title'
		);
    $hidden_field_name = 'pth_submit_hidden';

    $opt_val = array('default_tag' => get_option( $opt_name['default_tag'] ), 
    'default_number' => get_option( $opt_name['default_number'] ),
     'loading_str' => get_option( $opt_name['loading_str'] ),
      'update_str' => get_option( $opt_name['update_str'] ),
      'refresh_rate' => get_option( $opt_name['refresh_rate'] ),
      'title' => get_option( $opt_name['title'] )
    
    );
    
    if(isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {
    	
    	$opt_val = array('default_tag' => $_POST[ $opt_name['default_tag'] ],
    	'default_number' => $_POST[ $opt_name['default_number']],
    	'update_str' => $_POST[ $opt_name['update_str']],
    	'refresh_rate' => $_POST[ $opt_name['refresh_rate']],
    	'title' => $_POST[ $opt_name['title']]);

        update_option( $opt_name['default_tag'], $opt_val['default_tag'] );
        update_option( $opt_name['default_number'], $opt_val['default_number'] );
        update_option( $opt_name['update_str'], $opt_val['update_str'] );
        update_option( $opt_name['title'], $opt_val['title'] );
        
        $opt_val['refresh_rate'] = ($opt_val['refresh_rate'] < 24) ? 24: $opt_val['refresh_rate'];
        update_option( $opt_name['refresh_rate'], $opt_val['refresh_rate'] );
        
        ?>
<div id="message" class="updated fade">
  <p><strong>
    <?php _e('Options saved.', 'pth_trans_domain' ); ?>
    </strong></p>
</div>
<?php
    }
    
    
?>
<div class="wrap">
<h2>Twitter Hashtag Conversation</h2>
<p><?php _e('A shortcode that allows authors to insert a twitter stream based on a given hashtag  inside a post, page or custom post type.', 'pth_trans_domain'); ?></p>
<p><code>[twitter_hashtag hash="YOUR_TAG_WITHOUT_THE_#_SIGN" number="NUMBER_OF_TWEETS_TO_GET" ]</code></p>
<p><?php _e('If you simply want your twitter stream to use the default values, do not use any argument, just like this');?>: <code>[twitter_hashtag]</code></p>
<form name="pth_twitter_hashtag_options" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">


  <input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">

<table class="form-table">
	<tbody>


	<tr>
<th scope="row"><label for="pth_default_tag"><?php _e('Default hashtag to search') ?></label></th>
<td><input type="text" name="<?php echo $opt_name['default_tag']?>" value="<?php echo ($opt_val['default_tag'] !='')? $opt_val['default_tag']: 'wordpress'; ?>" id="pth_default_tag" /></td>
</tr>

	<tr>
<th scope="row"><label for="pth_default_title"><?php _e('Default title') ?></label></th>
<td><input type="text" name="<?php echo $opt_name['title']?>" value="<?php echo ($opt_val['title']!='')? $opt_val['title']: 'The twitter conversation on <em>{HASH}</em>'; ?>" id="pth_default_title" size="255" />
<br><small><?php _e('You can use <code title="Displays the keyword/hashtag">{HASH}</code>, <code title="Shows a link to the keyword\'s search results on twitter.com">{HASH_LINK}</code> and <code title="Shows the number of tweets displayed">{NUMBER}</code> in the title and they will be replaced by their value.');?></small></td>
</tr>

<tr>
<th scope="row"><label for="pth_default_number"><?php _e('Default number of tweets to fetch') ?></label></th>
<td><input type="text" name="<?php echo $opt_name['default_number']?>" value="<?php echo ($opt_val['default_number']!='')? $opt_val['default_number']: '25'; ?>" id="pth_default_number" size="2" /></td>
</tr>

	<tr>
<th scope="row"><label for="pth_loading_str"><?php _e('Initial loading message:') ?></label></th>
<td><input type="text" name="<?php echo $opt_name['loading_str']?>" value="<?php echo ($opt_val['loading_str']!='')? $opt_val['loading_str']: 'Chargement des tweets, un petit instant…'; ?>" id="pth_loading_str" size="100" /></td>
</tr>

	<tr>
<th scope="row"><label for="pth_update_str"><?php _e('Message: "updating the conversation" ') ?></label></th>
<td><input type="text" name="<?php echo $opt_name['update_str']?>" value="<?php echo ($opt_val['update_str']!='')? $opt_val['update_str']: 'Mise à jour…'; ?>" id="pth_update_str" /></td>
</tr>

	<tr>
<th scope="row"><label for="pth_refresh_rate"><?php _e('Number of seconds between each refresh ') ?></label><br><small><?php _e('Cannot be below 24 , see <a href="https://dev.twitter.com/docs/rate-limiting">Twitter Documentation</a>') ?></small></th>
<td><input type="text" name="<?php echo $opt_name['refresh_rate']?>" value="<?php echo ($opt_val['refresh_rate']!='')? $opt_val['refresh_rate']: '10'; ?>" id="pth_refresh_rate" /></td>
</tr>

<tr>
<th scope="row"></th>
<td><input type="submit" name="submit" id="submit" class="button-primary" value="Enregistrer les modifications"></td>
</tr>
</tbody>
</table>
</form>

<footer style="border-top:1px solid #DDD;margin-top:20px;"><a href="http://pixeline.be/downloads/twitter-hashtag-conversation-wordpress-plugin-980.html">Twitter Hashtag Conversation Wordpress Plugin</a> by <a href="http://pixeline.be">pixeline</a></footer>
</div>
<?
}

/*  --- FYI: JSON RETURNED BY TWITTER --- */

/*

{
            "created_at": "Sat, 28 Apr 2012 08:24:36 +0000",
            "from_user": "bgoss44",
            "from_user_id": 293901513,
            "from_user_id_str": "293901513",
            "from_user_name": "bertrand gosselin",
            "geo": null,
            "id": 196152924076904450,
            "id_str": "196152924076904448",
            "iso_language_code": "fr",
            "metadata": {
                "result_type": "recent"
            },
            "profile_image_url": "http://a0.twimg.com/profile_images/2057305770/image_normal.jpg",
            "profile_image_url_https": "https://si0.twimg.com/profile_images/2057305770/image_normal.jpg",
            "source": "&lt;a href=&quot;http://twitter.com/&quot;&gt;web&lt;/a&gt;",
            "text": "RT @Auregann: Pour finir la semaine, un peu de #dataviz ferroviaire : http://t.co/JfMioWhR à partir des données #opendata  @SNCFOpenData Bon week-end \\o/",
            "to_user": null,
            "to_user_id": null,
            "to_user_id_str": null,
            "to_user_name": null
        }

*/

?>
