/*
 * JavaScript Pretty Date
 * Copyright (c) 2011 John Resig (ejohn.org)
 * Licensed under the MIT and GPL licenses.
 */

// Takes an ISO time and returns a string representing how
// long ago the date represents.
function prettyDate(time){
	var date = new Date((time || "").replace(/-/g,"/").replace(/[TZ]/g," "));
	var	diff = (((new Date()).getTime() - date.getTime()) / 1000);
	var	day_diff = Math.floor(diff / 86400);
			
	if ( isNaN(day_diff) || day_diff < 0 || day_diff >= 31 )
		return;
			
	return day_diff == 0 && (
			diff < 60 && "à l'instant" ||
			diff < 120 && "il y a 1 minute" ||
			diff < 3600 && "Il y a "+Math.floor( diff / 60 ) + " minutes" ||
			diff < 7200 && "il y a 1 heure" ||
			diff < 86400 &&  "Il y a "+Math.floor( diff / 3600 ) + " heures") ||
		day_diff == 1 && "hier" ||
		day_diff < 7 &&  "Il y a "+day_diff + " jours" ||
		day_diff < 31 &&  "Il y a "+Math.ceil( day_diff / 7 ) + " semaines";
}
// If jQuery is included in the page, adds a jQuery plugin to handle it as well
if ( typeof jQuery != "undefined" )
	jQuery.fn.prettyDate = function(){
		return this.each(function(){
			var date = prettyDate(this.title);
			if ( date )
				jQuery(this).text( date );
		});
	};

/*--- Parsing twitter helpers --- */
String.prototype.parseHashtag = function() {
	return this.replace(/[#]+[A-Za-z0-9-_]+/g, function(t) {
		var tag = t.replace("#","%23")
		return t.link("http://search.twitter.com/search?q="+tag);
	});
};
String.prototype.parseUsername = function() {
	return this.replace(/[@]+[A-Za-z0-9-_]+/g, function(u) {
		var username = u.replace("@","")
		return u.link("http://twitter.com/"+username);
	});
};
String.prototype.parseURL = function() {
	return this.replace(/[A-Za-z]+:\/\/[A-Za-z0-9-_]+\.[A-Za-z0-9-_:%&~\?\/.=]+/g, function(url) {
		return url.link(url);
	});
};

// ------------------------------------------------------------
// !RUNTIME
// ------------------------------------------------------------
function twitter_hashtag_conversation_refresh(){
	var $thc_loading= jQuery('#thc_loading');
	$thc_loading.show();
	if(pixeline_twitter_hashtag.url){
		jQuery.getJSON(pixeline_twitter_hashtag.url,function(data){
		var tweet_html ='';
		$thc_loading.hide();
		jQuery.each(data.results, function(i, tweet) {
	        if(tweet.text !== undefined) {
				var hours = prettyDate(tweet.created_at);
	          var twitter_user = tweet.from_user;
	          var user_url = 'http://www.twitter.com/'+twitter_user;
	          var image_url = tweet.profile_image_url;
	          var tweet_url = 'http://www.twitter.com/'+twitter_user + '/status/' + tweet.id;
	          var text= tweet.text;
	          text = text.parseURL().parseUsername().parseHashtag();
	          // Build the html string for the current tweet
	          tweet_html += '<div class="thts-post"><a href="'+user_url+'" class="thts-profile"><img src="'+image_url+'" alt="'+twitter_user+'" class="thts-profile-thumb"/></a><p class="thts-message"><span class="thts-date">'+ hours +'</span><a href="'+user_url+'" class="thts-profile-username">'+tweet.from_user+'</a>'+text+' <a href="'+tweet_url+'" class="thts-sourcelink" title="Le lire sur twitter.com">&raquo;</a></p></div>';          
        }
        jQuery('#tht_tweet_container').html(tweet_html);
      });
	
	});

}
	
}
jQuery(function($){
	if(jQuery('#tht_tweet_container').length){
		jQuery('#tht_tweet_container').before('<div id="thc_loading">'+pixeline_twitter_hashtag.update_str+'</div>');
	jQuery('#thc_loading').hide();
	twitter_hashtag_conversation_refresh();
	
	var pth_interval = setInterval(twitter_hashtag_conversation_refresh,pixeline_twitter_hashtag.refresh_rate);
	}

});